/*
 * Illustrate differing behaviour of FILE streams on different runtime libraries.
 * 
 * On Ubuntu (Linux version 3.11.0-26-generic (buildd@comet) (gcc version 4.8.1 (Ubuntu/Linaro 4.8.1-10ubuntu8) ) #45-Ubuntu SMP Tue Jul 15 04:02:06 UTC 2014) the output is:
 * 
 *   Position of *FILE stream 1 is 10
 *   Position of *FILE stream 2 is 0
 *   After flushing stream 1, the position of *FILE stream 2 is 10
 * 
 * On an older SuSE (Linux version 2.6.34.10-0.6-desktop (geeko@buildhost) (gcc version 4.5.0 20100604 [gcc-4_5-branch revision 160292] (SUSE Linux) ) #1 SMP PREEMPT 2011-12-13 18:27:38 +0100) the output is:
 * 
 *   Position of *FILE stream 1 is 10
 *   Position of *FILE stream 2 is 10
 *   After flushing stream 1, the position of *FILE stream 2 is 10
 * 
 */

#include <stdio.h>

#define TESTFILE "testfile.tmp"

main() {

	char *data = "1234567890";
	FILE *fs1, *fs2;
	long pos1, pos2;

	remove(TESTFILE);

	fs1 = fopen(TESTFILE, "w");
	fwrite(data, 1, 10, fs1);
	pos1 = ftell(fs1);
	printf("Position of *FILE stream 1 is %ld\n", pos1);

	fs2 = fopen(TESTFILE, "r");
	fseek(fs2, 0, SEEK_END);
	pos2 = ftell(fs2);

	printf("Position of *FILE stream 2 is %ld\n", pos2);

	fflush(fs1);
	fseek(fs2, 0, SEEK_END);
	pos2 = ftell(fs2);

	printf("After flushing stream 1, the position of *FILE stream 2 is %ld\n", pos2);

	remove(TESTFILE);
}

